datablock ShapeBaseImageData(gagMuteImage)
{
	shapeFile = "./MouthGag.dts";
	mountPoint = $HeadSlot;
	offset = "0 0 0";
	eyeOffset = "0 0 -1000";
	rotation = eulerToMatrix("0 0 0");
	scale = "0.1 0.1 0.1";
	doColorShift = false;
};

function serverCmdGag(%client, %t0, %t1, %t2, %t3, %t4, %t5)
{
	if(!%client.isAdmin)
		return;

	%targetName = "";
	for(%i = 0; %i <= 5; %i++)
	{
		%targetName = %targetName SPC %t[%i];
	}
	%targetName = trim(%targetName);

	%target = findClientByName(%targetName);

	if(!isObject(%target))
	{
		%client.chatMessage("Nobody by that name could be found.");
		return;
	}

	%target.isGagged = true;

	if(isObject(%target.player))
		%target.player.applyMuteGag();
}

function player::applyMuteGag(%this)
{
	%this.mountImage(gagMuteImage, 2);
}

function serverCmdUnGag(%client, %t0, %t1, %t2, %t3, %t4, %t5)
{
	if(!%client.isAdmin)
		return;

	%targetName = "";
	for(%i = 0; %i <= 5; %i++)
	{
		%targetName = %targetName SPC %t[%i];
	}
	%targetName = trim(%targetName);

	%target = findClientByName(%targetName);

	if(!isObject(%target))
	{
		%client.chatMessage("Nobody by that name could be found.");
		return;
	}

	%target.isGagged = false;

	if(isObject(%target.player))
		if(%target.player.getMountedImage(2) == nameToID("gagMuteImage"))
			%target.player.unMountImage(2);
}

package gagMute
{
	function serverCmdMessageSent(%client, %message)
	{
		if(%client.isGagged && !%client.MCOverride)
			%message = gagFilter(%message);

		return parent::serverCmdMessageSent(%client, %message);
	}

	function serverCmdTeamMessageSent(%client, %message)
	{
		if(%client.isGagged && !%client.MCOverride)
			%message = gagFilter(%message);

		return parent::serverCmdMessageSent(%client, %message);
	}

	function gameConnection::spawnPlayer(%this)
	{
		%return = parent::spawnPlayer(%this);

		if(isObject(%this.player) && %this.isGagged)
			%this.player.applyMuteGag();
	}

	function player::mountImage(%this, %image, %slot)
	{
		if(%this.getMountedImage(2) == nameToID("gagMuteImage") && %this.client.isGagged)
			return;

		return parent::mountImage(%this, %image, %slot);
	}
};
activatePackage(gagMute);


function gagFilter(%message)
{
	for(%i = 0; %i < getWordCount(%message); %i++)
	{
		%word = getWord(%message, %i);

		if(strpos(".?!,;:-", charAt(%word, strlen(%word) - 1)) > -1)
		{
			%punctuation = charAt(%word, strlen(%word) - 1);
			%word = getSubStr(%word, 0, strlen(%word) - 1);
		}
		else
			%punctuation = "";

		switch(strlen(%word))
		{
			case 0:
				continue;

			case 1:
				if(isCapitalLetter(%word))
					%word = "M";
				else
					%word = "m";

			case 2:
				if(isCapitalLetter(charAt(%word, 0)))
					%replace = "M";
				else
					%replace = "m";

				if(isCapitalLetter(charAt(%word, 1)))
					%replace = %replace @ "F";
				else
					%replace = %replace @ "f";

				%word = %replace;

			case 3:
				if(isCapitalLetter(charAt(%word, 0)))
					%replace = "M";
				else
					%replace = "m";

				if(isCapitalLetter(charAt(%word, 1)))
					%replace = %replace @ "H";
				else
					%replace = %replace @ "h";

				if(isCapitalLetter(charAt(%word, 2)))
					%replace = %replace @ "F";
				else
					%replace = %replace @ "f";

				%word = %replace;

			default:
				// 4 or more letters
				%newWord = "";
				for(%j = 0; %j < strlen(%word); %j++)
				{
					if(%j < strlen(%word) / 3)
						%letter = "m";
					else if(%j >= strlen(%word) / 3 && %j < strlen(%word) * 0.66)
						%letter = "p";
					else if(%j >= strlen(%word) * 0.66 && %j != strlen(%word) - 1)
						%letter = "h";
					else
						%letter = "f";

					if(isCapitalLetter(charAt(%word, %j)))
						%letter = strUpr(%letter);

					%newWord = %newWord @ %letter;
				}

				%word = %newWord;
		}

		%message = setWord(%message, %i, %word @ %punctuation);
	}

	return %message;
}

function charAt(%string, %index)
{
	return getSubStr(%string, %index, 1);
}

function isCapitalLetter(%letter)
{
	if(strPos("ABCDEFGHIJKLMNOPQRSTUVWXYZ", %letter) > -1)
		return true;
	return false;
}